/*!
  \file orxonox_gui_keys.h
  \brief File that holds the class that creates the Keyboard-Options.
*/

#ifndef _ORXONOX_GUI_KEYS_H
#define _ORXONOX_GUI_KEYS_H

#include "orxonox_gui.h"
#include <gdk/gdkkeysyms.h>

/**
 * defines the Possible Player Keys
 */
enum KEYS { UP, DOWN, LEFT, RIGHT, SHOOT };

//! Class to hold infos about a Player
class Player
{
 private:
  Window* keyWindow;
  bool windowIsOpen;
  Button* openButton;


  Box* keyBox;
  Button* Keys[10];


 public:
  Player(char* player);

  Button* getOpenButton();
  
  void openWindow ();

  static gint openWindowEvent(GtkWidget* widget, GdkEvent* event, void* player);
  void setkey(KEYS key);
  
};

//! Class that creates the Keys-Options.
class OrxonoxGuiKeys
{
 private:
  Frame* keysFrame;
  Box* keysBox;
  Player* player1;
  Player* player2;
  Button* misc;

 public:
  OrxonoxGuiKeys ();
  ~OrxonoxGuiKeys ();
  
  Widget* getWidget ();
};



gint key_cb(GtkWidget* w, GdkEventKey* event, void* Widget);

#endif /* _ORXONOX_GUI_KEYS_H */
